<template>
  <b-button
    variant="secondary"
    v-b-modal.set-combinationfilter-modal
    @click="oclf = system.combinationFilter"
    v-if="
      system &&
        system.properties &&
        system.properties.length &&
        system.combinationFilter &&
        me &&
        me.groups.includes('MOD')
    "
  >
    <b-icon-funnel />
    CombinationFilter

    <b-modal
      id="set-combinationfilter-modal"
      :title="`Set combination filter`"
      @ok="submit"
      ok-variant="success"
      :ok-disabled="!!validationError"
    >
      <p>
        You can specify an expression to filter out invalid or unneeded property
        combinations.
      </p>

      <label
        @click="specificationVisible = !specificationVisible"
        for="specification"
      >
        <b-icon-chevron-right v-show="!specificationVisible" />
        <b-icon-chevron-down v-show="specificationVisible" />
        Formal specification
      </label>
      <b-collapse :visible="specificationVisible" id="specification">
        <p>
          The OPEN-CUTS Combination Filtering Language (OCFL) is a simple
          logical language for creating boolean expressions that are compiled
          into MongoDB Aggregation pipelines. The Language is a subset of JSON.
        </p>
        <pre>
exp       : &lt;check&gt; | &lt;unaryexp&gt; | &lt;binaryexp&gt; | &lt;chainexp&gt;
check     : { CHECK: [&lt;stringterminal&gt;, [&lt;stringterminal&gt;, ...]] }
unaryexp  : { &lt;unaryop&gt;: [&lt;exp&gt;] }
unaryop   : NOT
binaryexp : { &lt;binaryop&gt;: [&lt;exp&gt;, &lt;exp&gt;] }
binaryop  : IMPLIES
chainexp  : { &lt;chainop&gt;: [&lt;exp&gt;, ...] }
chainop   : AND | OR</pre
        >
      </b-collapse>
      <br />

      <label @click="exampleVisible = !exampleVisible" for="example">
        <b-icon-chevron-right v-show="!exampleVisible" />
        <b-icon-chevron-down v-show="exampleVisible" />
        Example
      </label>
      <b-collapse :visible="exampleVisible" id="example">
        <p>
          This OCFL statement would only check for combinations where the
          {{ system.properties[0].name }} property is
          {{ system.properties[0].values[0] }} or
          {{ system.properties[0].values[1] }}.
        </p>
        <pre>
{
  "CHECK": [
    "{{ system.properties[0].name }}", [
      "{{ system.properties[0].values[0] }}",
      "{{ system.properties[0].values[1] }}"
    ]
  ]
}</pre
        >
      </b-collapse>
      <br />

      <label @click="propertiesVisible = !propertiesVisible" for="properties">
        <b-icon-chevron-right v-show="!propertiesVisible" />
        <b-icon-chevron-down v-show="propertiesVisible" />
        Properties
      </label>
      <b-collapse :visible="propertiesVisible" id="properties">
        <ul>
          <li v-for="prop in system.properties" v-bind:key="prop.name">
            <b>{{ prop.name }}</b
            >: {{ prop.values.join(", ") }}
          </li>
        </ul>
      </b-collapse>

      <b-form>
        <label for="description">OCFL expression</label>
        <b-form-textarea
          id="description"
          v-model="ocfl"
          placeholder="OCFL expression"
          rows="8"
          trim
        />
        <b-button @click="prettify" :disabled="!!validationError">
          <b-icon-hammer />
          Prettify OCFL
        </b-button>
      </b-form>
      <!-- TODO display filtered combinations as set expression using mathjax -->

      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>
      <p v-show="validationError" style="color: red">
        Your OCFL expression is invalid: {{ validationError }}
      </p>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "SetCombinationFilter",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      ocfl: this.system.combinationFilter,
      specificationVisible: false,
      exampleVisible: false,
      propertiesVisible: false
    };
  },
  computed: {
    validationError() {
      // TODO validate more than just json
      try {
        if (!this.ocfl) return null;
        JSON.parse(this.ocfl);
        return null;
      } catch (error) {
        return error;
      }
    }
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    system: Object
  },
  methods: {
    prettify() {
      this.ocfl = JSON.stringify(JSON.parse(this.ocfl), null, " ");
    },
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($systemId: ID!, $combinationFilter: String!) {
              setCombinationFilter(
                id: $systemId
                combinationFilter: $combinationFilter
              ) {
                id
              }
            }
          `,
          variables: {
            systemId: this.system.id,
            combinationFilter: this.ocfl || "{}"
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
